--- chan_unistim.c.orig	2011-10-11 11:33:06.000000000 -0500
+++ chan_unistim.c	2011-10-11 11:42:22.000000000 -0500
@@ -5182,19 +6094,25 @@
 			ringvolume = atoi(v->value);
 		else if (!strcasecmp(v->name, "ringstyle"))
 			ringstyle = atoi(v->value);
+		else if (!strcasecmp(v->name, "cwvolume"))
+			cwvolume = atoi(v->value);
+		else if (!strcasecmp(v->name, "cwstyle"))
+			cwstyle = atoi(v->value);
 		else if (!strcasecmp(v->name, "callhistory"))
 			callhistory = atoi(v->value);
-		else if (!strcasecmp(v->name, "callerid")) {
+		else if (!strcasecmp(v->name, "sharpdial")) {
+			sharpdial = ast_true(v->value) ? 1 : 0;
+		} else if (!strcasecmp(v->name, "callerid")) {
 			if (!strcasecmp(v->value, "asreceived"))
-				l->cid_num[0] = '\0';
+				lt->cid_num[0] = '\0';
 			else
-				ast_copy_string(l->cid_num, v->value, sizeof(l->cid_num));
+				ast_copy_string(lt->cid_num, v->value, sizeof(lt->cid_num));
 		} else if (!strcasecmp(v->name, "language"))
-			ast_copy_string(l->language, v->value, sizeof(l->language));
+			ast_copy_string(d->language, v->value, sizeof(d->language));
 		else if (!strcasecmp(v->name, "country"))
 			ast_copy_string(d->country, v->value, sizeof(d->country));
 		else if (!strcasecmp(v->name, "accountcode"))
-			ast_copy_string(l->accountcode, v->value, sizeof(l->accountcode));
+			ast_copy_string(lt->accountcode, v->value, sizeof(lt->accountcode));
 		else if (!strcasecmp(v->name, "amaflags")) {
 			int y;
 			y = ast_cdr_amaflags2int(v->value);
@@ -5202,17 +6120,17 @@
 				ast_log(LOG_WARNING, "Invalid AMA flags: %s at line %d\n", v->value,
 						v->lineno);
 			else
-				l->amaflags = y;
+				lt->amaflags = y;
 		} else if (!strcasecmp(v->name, "musiconhold"))
-			ast_copy_string(l->musicclass, v->value, sizeof(l->musicclass));
+			ast_copy_string(lt->musicclass, v->value, sizeof(lt->musicclass));
 		else if (!strcasecmp(v->name, "callgroup"))
-			l->callgroup = ast_get_group(v->value);
+			lt->callgroup = ast_get_group(v->value);
 		else if (!strcasecmp(v->name, "pickupgroup"))
-			l->pickupgroup = ast_get_group(v->value);
+			lt->pickupgroup = ast_get_group(v->value);
 		else if (!strcasecmp(v->name, "mailbox"))
-			ast_copy_string(l->mailbox, v->value, sizeof(l->mailbox));
+			ast_copy_string(lt->mailbox, v->value, sizeof(lt->mailbox));
 		else if (!strcasecmp(v->name, "parkinglot"))
-			ast_copy_string(l->parkinglot, v->value, sizeof(l->parkinglot));
+			ast_copy_string(lt->parkinglot, v->value, sizeof(lt->parkinglot));
 		else if (!strcasecmp(v->name, "linelabel"))
 			unquote(linelabel, v->value, sizeof(linelabel) - 1);
 		else if (!strcasecmp(v->name, "extension")) {
@@ -5229,103 +6147,93 @@
 				ast_log(LOG_WARNING,
 						"More than 6 softkeys defined. Ignoring new entries.\n");
 			else {
-				if (ParseBookmark(v->value, d))
+				if (parse_bookmark(v->value, d))
 					nbsoftkey++;
 			}
 		} else if (!strcasecmp(v->name, "line")) {
 			int len = strlen(linelabel);
+			int create_line = 0;
 
-			if (nbsoftkey) {
-				ast_log(LOG_WARNING,
-						"You must use bookmark AFTER line=>. Only one line is supported in this version\n");
-				if (create) {
+			l = find_line_by_number(d, v->value);
+			if (!l) { /* If line still not exists */
+				if (!(l = unistim_line_alloc())) {
 					ast_free(d);
-					ast_free(l);
+					ast_free(lt);
+					return NULL;
 				}
-				return NULL;
-			}
-			if (create) {
+				lt->capability = l->capability;
+				memcpy(l, lt, sizeof(*l));
 				ast_mutex_init(&l->lock);
-			} else {
-				d->to_delete = 0;
-				/* reset bookmarks */
-				memset(d->softkeylabel, 0, sizeof(d->softkeylabel));
-				memset(d->softkeynumber, 0, sizeof(d->softkeynumber));
-				memset(d->softkeyicon, 0, sizeof(d->softkeyicon));
-				memset(d->softkeydevice, 0, sizeof(d->softkeydevice));
-				memset(d->sp, 0, sizeof(d->sp));
-			}
-			ast_copy_string(l->name, v->value, sizeof(l->name));
-			snprintf(l->fullname, sizeof(l->fullname), "USTM/%s@%s", l->name, d->name);
-			d->softkeyicon[0] = FAV_ICON_ONHOOK_BLACK;
+				create_line = 1;
+			}
+			d->to_delete = 0;
+
+			/* Set softkey info for new line*/
+			d->sline[nbsoftkey] = l;
+			d->softkeyicon[nbsoftkey] = FAV_LINE_ICON;
 			if (!len)		       /* label is undefined ? */
-				ast_copy_string(d->softkeylabel[0], v->value, sizeof(d->softkeylabel[0]));
+				ast_copy_string(d->softkeylabel[nbsoftkey], v->value, sizeof(d->softkeylabel[nbsoftkey]));
 			else {
+				int softkeylinepos = 0;
 				if ((len > 2) && (linelabel[1] == '@')) {
-					d->softkeylinepos = linelabel[0];
-					if ((d->softkeylinepos >= '0') && (d->softkeylinepos <= '5')) {
-						d->softkeylinepos -= '0';
-						d->softkeyicon[0] = 0;
+					softkeylinepos = linelabel[0];
+					if ((softkeylinepos >= '0') && (softkeylinepos <= '5')) {
+						softkeylinepos -= '0';
+						d->softkeyicon[nbsoftkey] = FAV_ICON_NONE;
 					} else {
 						ast_log(LOG_WARNING,
 								"Invalid position for linelabel : must be between 0 and 5\n");
-						d->softkeylinepos = 0;
 					}
-					ast_copy_string(d->softkeylabel[d->softkeylinepos], linelabel + 2,
-									sizeof(d->softkeylabel[d->softkeylinepos]));
-					d->softkeyicon[d->softkeylinepos] = FAV_ICON_ONHOOK_BLACK;
+					ast_copy_string(d->softkeylabel[softkeylinepos], linelabel + 2,
+									sizeof(d->softkeylabel[softkeylinepos]));
+					d->softkeyicon[softkeylinepos] = FAV_LINE_ICON;
 				} else
-					ast_copy_string(d->softkeylabel[0], linelabel,
-									sizeof(d->softkeylabel[0]));
+					ast_copy_string(d->softkeylabel[nbsoftkey], linelabel,
+									sizeof(d->softkeylabel[nbsoftkey]));
 			}
 			nbsoftkey++;
-			ast_copy_string(l->context, context, sizeof(l->context));
-			if (!ast_strlen_zero(l->mailbox)) {
-				if (unistimdebug)
-					ast_verb(3, "Setting mailbox '%s' on %s@%s\n", l->mailbox, d->name, l->name);
-			}
-
-			l->capability = CAPABILITY;
-			l->parent = d;
-
-			if (create) {
-				if (!alloc_sub(l, SUB_REAL)) {
-					ast_mutex_destroy(&l->lock);
-					ast_free(l);
-					ast_free(d);
-					return NULL;
+                        
+			if (create_line) {
+				ast_copy_string(l->name, v->value, sizeof(l->name));
+				snprintf(l->fullname, sizeof(l->fullname), "USTM/%s@%s", l->name, d->name);
+				if (!ast_strlen_zero(l->mailbox)) {
+					if (unistimdebug)
+						ast_verb(3, "Setting mailbox '%s' on %s@%s\n", l->mailbox, d->name, l->name);
 				}
-				l->next = d->lines;
-				d->lines = l;
+				l->capability = CAPABILITY;
+				l->parent = d;
+				linecnt++;
+				AST_LIST_LOCK(&d->lines);
+				AST_LIST_INSERT_TAIL(&d->lines, l, list);
+				AST_LIST_UNLOCK(&d->lines);
 			}
 		} else if (!strcasecmp(v->name, "height")) {
 			/* Allow the user to lower the expected display lines on the phone
-			 * For example the Nortal I2001 and I2002 only have one ! */
+			 * For example the Nortel i2001 and i2002 only have one ! */
 			d->height = atoi(v->value);
 		} else
 			ast_log(LOG_WARNING, "Don't know keyword '%s' at line %d\n", v->name,
 					v->lineno);
 		v = v->next;
 	}
+	ast_free(lt);
+	if (linecnt == 0) {
+		ast_log(LOG_ERROR, "An Unistim device must have at least one line!\n");
+		ast_free(d);
+		return NULL;
+	}
 	d->ringvolume = ringvolume;
 	d->ringstyle = ringstyle;
+	d->cwvolume = cwvolume;
+	d->cwstyle = cwstyle;
 	d->callhistory = callhistory;
+	d->sharp_dial = sharpdial;
 	d->tz = ast_get_indication_zone(d->country);
 	if ((d->tz == NULL) && !ast_strlen_zero(d->country))
 		ast_log(LOG_WARNING, "Country '%s' was not found in indications.conf\n",
 				d->country);
 	d->datetimeformat = 56 + (dateformat * 4);
 	d->datetimeformat += timeformat;
-	if (!d->lines) {
-		ast_log(LOG_ERROR, "An Unistim device must have at least one line!\n");
-		ast_mutex_destroy(&l->lock);
-		ast_free(l);
-		if (d->tz) {
-			d->tz = ast_tone_zone_unref(d->tz);
-		}
-		ast_free(d);
-		return NULL;
-	}
 	if ((autoprovisioning == AUTOPROVISIONING_TN) &&
 		(!ast_strlen_zero(d->extension_number))) {
 		d->extension = EXTENSION_TN;
@@ -5338,8 +6246,6 @@
 	} else if (ast_strlen_zero(d->id)) {
 		if (strcmp(d->name, "template")) {
 			ast_log(LOG_ERROR, "You must specify the mac address with device=\n");
-			ast_mutex_destroy(&l->lock);
-			ast_free(l);
 			if (d->tz) {
 				d->tz = ast_tone_zone_unref(d->tz);
 			}
@@ -5352,8 +6258,6 @@
 		d->rtp_port = 10000;
 	if (d->contrast == -1)
 		d->contrast = 8;
-	if (ast_strlen_zero(d->maintext0))
-		strcpy(d->maintext0, "Welcome");
 	if (ast_strlen_zero(d->maintext1))
 		strcpy(d->maintext1, d->name);
 	if (ast_strlen_zero(d->titledefault)) {
@@ -5361,7 +6265,6 @@
 		struct timeval cur_time = ast_tvnow();
 
 		if ((ast_localtime(&cur_time, &tm, 0)) == 0 || ast_strlen_zero(tm.tm_zone)) {
-			display_last_error("Error in ast_localtime()");
 			ast_copy_string(d->titledefault, "UNISTIM for*", 12);
 		} else {
 			if (strlen(tm.tm_zone) < 4) {
@@ -5439,13 +6342,16 @@
                 } else if (!strcasecmp(v->name, "cos_audio")) {
                         if (ast_str2cos(v->value, &qos.cos_audio))
                             ast_log(LOG_WARNING, "Invalid cos_audio value at line %d, refer to QoS documentation\n", v->lineno);
+		} else if (!strcasecmp(v->name, "debug")) {
+			if (!strcasecmp(v->value, "no"))
+				unistimdebug = 0;
+			else if (!strcasecmp(v->value, "yes"))
+				unistimdebug = 1;
 		} else if (!strcasecmp(v->name, "autoprovisioning")) {
 			if (!strcasecmp(v->value, "no"))
 				autoprovisioning = AUTOPROVISIONING_NO;
 			else if (!strcasecmp(v->value, "yes"))
 				autoprovisioning = AUTOPROVISIONING_YES;
-			else if (!strcasecmp(v->value, "db"))
-				autoprovisioning = AUTOPROVISIONING_DB;
 			else if (!strcasecmp(v->value, "tn"))
 				autoprovisioning = AUTOPROVISIONING_TN;
 			else
@@ -5498,44 +6404,52 @@
 	d = devices;
 	while (d) {
 		if (d->to_delete) {
-			int i;
+			struct unistim_line *l;
+			struct unistim_subchannel *sub;
 
 			if (unistimdebug)
 				ast_verb(0, "Removing device '%s'\n", d->name);
-			if (!d->lines) {
-				ast_log(LOG_ERROR, "Device '%s' without a line !, aborting\n", d->name);
-				ast_config_destroy(cfg);
-				return 0;
-			}
-			if (!d->lines->subs[0]) {
-				ast_log(LOG_ERROR, "Device '%s' without a subchannel !, aborting\n",
-						d->name);
-				ast_config_destroy(cfg);
-				return 0;
-			}
-			if (d->lines->subs[0]->owner) {
-				ast_log(LOG_WARNING,
-						"Device '%s' was not deleted : a call is in progress. Try again later.\n",
-						d->name);
-				d = d->next;
-				continue;
-			}
-			ast_mutex_destroy(&d->lines->subs[0]->lock);
-			ast_free(d->lines->subs[0]);
-			for (i = 1; i < MAX_SUBS; i++) {
-				if (d->lines->subs[i]) {
+
+			AST_LIST_LOCK(&d->subs);
+			AST_LIST_TRAVERSE_SAFE_BEGIN(&d->subs, sub, list){
+				if (sub->subtype == SUB_REAL) {
+					if (!sub) {
+						ast_log(LOG_ERROR, "Device '%s' without a subchannel !, aborting\n",
+								d->name);
+						ast_config_destroy(cfg);
+						return 0;
+					}
+					if (sub->owner) {
+						ast_log(LOG_WARNING,
+								"Device '%s' was not deleted : a call is in progress. Try again later.\n",
+								d->name);
+						d = d->next;
+						continue;
+					}
+				}
+				if (sub->subtype == SUB_THREEWAY) {
 					ast_log(LOG_WARNING,
 							"Device '%s' with threeway call subchannels allocated, aborting.\n",
 							d->name);
 					break;
 				}
+				AST_LIST_REMOVE_CURRENT(list);
+				ast_mutex_destroy(&sub->lock);
+				ast_free(sub);
+			}
+			AST_LIST_TRAVERSE_SAFE_END
+			AST_LIST_UNLOCK(&d->subs);
+
+
+			AST_LIST_LOCK(&d->lines);
+			AST_LIST_TRAVERSE_SAFE_BEGIN(&d->lines, l, list){
+				AST_LIST_REMOVE_CURRENT(list);
+				ast_mutex_destroy(&l->lock);
+				unistim_line_destroy(l);
 			}
-			if (i < MAX_SUBS) {
-				d = d->next;
-				continue;
-			}
-			ast_mutex_destroy(&d->lines->lock);
-			ast_free(d->lines);
+			AST_LIST_TRAVERSE_SAFE_END
+			AST_LIST_UNLOCK(&d->lines);
+
 			if (d->session) {
 				if (sessions == d->session)
 					sessions = d->session->next;
@@ -5567,6 +6481,7 @@
 			if (d->tz) {
 				d->tz = ast_tone_zone_unref(d->tz);
 			}
+			ast_mutex_destroy(&d->lock);
 			ast_free(d);
 			d = devices;
 			continue;
@@ -5579,8 +6494,14 @@
 	ast_mutex_lock(&sessionlock);
 	s = sessions;
 	while (s) {
-		if (s->device)
+		if (s->device) {
 			refresh_all_favorite(s);
+			if (ast_strlen_zero(s->device->language)) {
+				struct unistim_languages lang;
+				lang = options_languages[find_language(s->device->language)];
+				send_charset_update(s, lang.encoding);
+			}
+		}
 		s = s->next;
 	}
 	ast_mutex_unlock(&sessionlock);
@@ -5694,8 +6615,9 @@
 static int unload_module(void)
 {
 	/* First, take us out of the channel loop */
-	if (sched)
+	if (sched) {
 		sched_context_destroy(sched);
+	}
 
 	ast_cli_unregister_multiple(unistim_cli, ARRAY_LEN(unistim_cli));
 
@@ -5722,7 +6644,16 @@
 /*! reload: Part of Asterisk module interface ---*/
 int reload(void)
 {
-	unistim_reload(NULL, 0, NULL);
+	if (unistimdebug)
+		ast_verb(0, "reload unistim\n");
+
+	ast_mutex_lock(&unistim_reload_lock);
+	if (!unistim_reloading)
+		unistim_reloading = 1;
+	ast_mutex_unlock(&unistim_reload_lock);
+
+	restart_monitor();
+	
 	return 0;
 }
 
